/* ***** BEGIN LICENSE BLOCK *****
 * Version: GPL 2.0
 *
 * This code is part of DownThemAll! - dTa!
 * Copyright © 2004-2006 Federico Parodi and Stefano Verna.
 * 
 * See notice.txt and gpl.txt for details.
 *
 * ***** END LICENSE BLOCK ***** */

var dragObserverTdTa = {
	getSupportedFlavours: function () {
		var flavours = new FlavourSet ();
		flavours.appendFlavour("text/x-moz-url");
		return flavours;
	},
	onDragOver: function(evt,flavour,session) {},
	onDrop: function (evt,dropdata,session) {
		if (dropdata != "") {
			var url = transferUtils.retrieveURLFromData(dropdata.data, dropdata.flavour.contentType);
			DTA_AddingFunctions.saveSingleLink(true, url, document.commandDispatcher.focusedWindow.document.URL ? document.commandDispatcher.focusedWindow.document.URL : DTA_AddingFunctions.getMostRecentWindow() , "");
		}
	}
};

var dragObserverdTa = {
	getSupportedFlavours: function () {
		var flavours = new FlavourSet ();
    	flavours.appendFlavour("text/x-moz-url");
		return flavours;
	},
	onDragOver: function(evt,flavour,session) {},
	onDrop: function (evt,dropdata,session) {
		if (dropdata != "") {
			var url = transferUtils.retrieveURLFromData(dropdata.data, dropdata.flavour.contentType);
			DTA_AddingFunctions.saveSingleLink(false, url, document.commandDispatcher.focusedWindow.document.URL ? document.commandDispatcher.focusedWindow.document.URL : DTA_AddingFunctions.getMostRecentWindow(), "");
		}
	}
};

// turbo: 4 stati:
// 0: dta normale
// 1: tdta
// 2: dta di un singolo link
// 3: tdta di un singolo link
// sends valid links to dialog win
	
var DTA_AddingFunctions = {
	
	getMostRecentWindow : function() {
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
  var recentWindow = wm.getMostRecentWindow("navigator:browser");
  return recentWindow ? recentWindow.content.document.location : "";
	},
	
	isLinkOpenable : function(t) {
		return t.match(/^(http|ftp|https):\/\/.+/i)
	},
	
	downloadElement : function (url, refPage, desc) {
		this.url = url;
		this.description = desc;
		this.refPage = refPage;
	},

	saveSingleLink : function(turbo, link, referrer, description) {try {
		if (this.isLinkOpenable(link)) {

			// se un solo file
			var e = new this.downloadElement(link, referrer, description);
			
			window.openDialog("chrome://dta/content/dta/addurl.xul","_blank","chrome,centerscreen,dialog=no", turbo, e);

		} else
			alert(document.getElementById("context-dta").attributes.error2.value);
			
	} catch(e) {
		alert("saveLink(): " + e);
	}
	},
	
	saveLinkArray : function(turbo, urls, images) {
		if (urls.length > 0 || images.length > 0)
			window.openDialog("chrome://dta/content/dta/select.xul","_blank","chrome,centerscreen,resizable=yes,dialog=no", urls, images, turbo?1:0);
		else {
			// localization hack
			alert(document.getElementById("context-dta").attributes.error1.value);
			return -1;
		}
	},
	
	openManager : function () {try {
	
		var trovato = false;
		var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var enumerator;
		
		enumerator = mediator.getEnumerator(null);
		
		while (enumerator.hasMoreElements()) {
			var win = enumerator.getNext();
			if (win.location == "chrome://dta/content/dta/manager.xul") {
				trovato = true;
				win.focus();
				break;
			}
		}
		
		if (!trovato) {
			window.openDialog("chrome://dta/content/dta/manager.xul", "", "chrome, centerscreen, resizable=yes, dialog=no");
		}
	
	} catch(e) {}
	},
	
	_pref : null,
	getPreference : function (stringa, predefinito) {
		if (this._pref==null)
			this._pref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
		try {
			if (typeof(predefinito) == "boolean")
				var scelta = this._pref.getBoolPref(stringa);
			else if (typeof(predefinito) == "string")
				var scelta = this._pref.getCharPref(stringa);
			else if (typeof(predefinito) == "number")
				var scelta = this._pref.getIntPref(stringa);
			return scelta;
		} catch (e) {
			if (typeof(predefinito) == "boolean")
				var scelta = this._pref.setBoolPref(stringa, predefinito);
			else if (typeof(predefinito) == "string")
				var scelta = this._pref.setCharPref(stringa, predefinito);
			else
				var scelta = this._pref.setIntPref(stringa, predefinito);
			return predefinito;
		}
	},
	
	sendToDown : function(notQueue, links) {
		var trovato = false;
		var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		
		// find window
		var enumerator = mediator.getEnumerator(null);
		while (enumerator.hasMoreElements()) {
			var win = enumerator.getNext();
			if (win.location == "chrome://dta/content/dta/manager.xul") {
				win.self.startnewDownloads(notQueue, links);
				trovato = true;
				break;
			}
		}
		if (!trovato) {
			window.openDialog("chrome://dta/content/dta/manager.xul", "", "chrome, centerscreen, resizable=yes, dialog=no", notQueue, links);
		}
	}
}
