/* ***** BEGIN LICENSE BLOCK *****
 * Version: GPL 2.0
 *
 * This code is part of DownThemAll! - dTa!
 * Copyright © 2004-2006 Federico Parodi and Stefano Verna.
 * 
 * See notice.txt and gpl.txt for details.
 *
 * ***** END LICENSE BLOCK ***** */

var defNumFilters = 7;
var currentVersion = "0.9.9.3";

function isNewer(version, current) {

	var ver = version.split(".");
	var cur = current.split(".");
	
	var i = 0;
	while (ver[i] == cur[i] && i<ver.length && i<cur.length) 
		i++;
	
	if (i == cur.length) 
		return false;
	if (Number(ver[i]) > Number(cur[i]))
		return true;
	else
		return false;
}

function versionControl() {
	if (Preferences.get("extensions.dta.version", "0")=="0") {
			Debug.dump("version read: " + Preferences.get("extensions.dta.version", "0") + " - Deleting old preferences");
			Preferences.set("extensions.dta.version", currentVersion);
			restoreAll();
			if (typeof(showFilter) == "function") showFilter(true);
	}
	if (Preferences.get("extensions.dta.version", "0")!=currentVersion) {
		if (isNewer("0.9.8.7", Preferences.get("extensions.dta.version", "0"))) {
			// Traduco le vecchie dropdown nelle nuove preferenze
			var v;
			if (((v = Preferences.get("extensions.dta.directory", "")) != "") && (Preferences.get("extensions.dta.dropdown.directory-current", "") == "")) {
				Preferences.set("extensions.dta.dropdown.directory-current", v.split("|")[0]);
				Preferences.set("extensions.dta.dropdown.directory-history", v.split("|").join("|@|"));
			}
			if ((v = Preferences.get("extensions.dta.filters", "")) != "" && (Preferences.get("extensions.dta.dropdown.filter-history", "") == ""))
				Preferences.set("extensions.dta.dropdown.filter-history", v);
				
			if ((v = Preferences.get("extensions.dta.filter", "")) != "" && (Preferences.get("extensions.dta.dropdown.filter-current", "") == "")) 
				Preferences.set("extensions.dta.dropdown.filter-current", v);
			
			if ((v = Preferences.get("extensions.dta.rename.files", "")) != "" && (Preferences.get("extensions.dta.dropdown.renaming-current", "") == "")) {
				Preferences.set("extensions.dta.dropdown.renaming-current", v);
			}
		}
		Preferences.set("extensions.dta.version", currentVersion);
		window.openDialog("chrome://dta/content/dta/privacy.xul","_blank","chrome, centerscreen, resizable=no, dialog=yes, close=no");
		if (typeof(showFilter) == "function") showFilter(true);
	}
}

function restoreAll() {
try {
	Preferences.removeBranch("extensions.dta");
	Preferences.set("extensions.dta.context.menu", "1,1,0");
	Preferences.set("extensions.dta.context.compactmenu", false);
	Preferences.set("extensions.dta.tool.menu", "1,1,1");
	Preferences.set("extensions.dta.tool.compactmenu", true);
	Preferences.set("extensions.dta.context.highlight", true);
	Preferences.set("extensions.dta.context.closetab", false);
	Preferences.set("extensions.dta.context.closedta", false);
	Preferences.set("extensions.dta.context.reduce", true);
	Preferences.set("extensions.dta.context.saveTemp", true);
	Preferences.set("extensions.dta.context.downloadWin", true);
	Preferences.set("extensions.dta.existing", 3);
	Preferences.set("extensions.dta.context.ntask",4);
	Preferences.set("extensions.dta.context.timeoutsel",6);
	Preferences.set("extensions.dta.context.maxchunks", 5);
	Preferences.set("extensions.dta.context.history", 5);
	Preferences.set("extensions.dta.alertbox", 2);
	Preferences.set("extensions.dta.context.removecompleted", true);
	Preferences.set("extensions.dta.context.removecanceled", false);
	Preferences.set("extensions.dta.context.removeaborted", false);
	Preferences.set("extensions.dta.context.infophrases", true);
	Preferences.set("extensions.dta.directory.visibledump", false);
	Preferences.set("extensions.dta.context.showOnlyFilenames", true);
	Preferences.set("extensions.dta.sounds.done", true);
	Preferences.set("extensions.dta.sounds.error", false);
	defaultFilters();
} catch(e) {}
}

function restoreFilter(i,caption,filter,checked,link,image) {
	nsPreferences.setUnicharPref("extensions.dta.context.filter"+i+".caption", caption);
	nsPreferences.setUnicharPref("extensions.dta.context.filter"+i+".filter", filter);
	Preferences.set("extensions.dta.context.filter"+i+".checked", checked);
	Preferences.set("extensions.dta.context.filter"+i+".isImageFilter", image);
	Preferences.set("extensions.dta.context.filter"+i+".isLinkFilter", link);
}

function defaultFilters() {
	var strbundleB = document.getElementById("stringB");
	restoreFilter(0,strbundleB.getString("allfiles"),"/(\\.*)/", false, true, true);
	restoreFilter(1,strbundleB.getString("arch"), "/(\\.(z(ip|[0-9]{2})|r(ar|[0-9]{2})|jar|bz2|gz|tar|rpm))$/", false, true, false);
	restoreFilter(2,strbundleB.getString("vid"), "/(\\.(mpeg|rm|mpe|avi|mpg|mp4|mov|divx|asf|qt|wmv|ram|m1v|m2v|rv|vob|asx))$/", false, true, false);
	restoreFilter(3,strbundleB.getString("images"), "/(\\.(jpeg|jpg|gif|png|jpe|tif|tiff|bmp|ico))$/", false, true, false);
	restoreFilter(4,"*.jpeg", "/(\\.(jpeg|jpg|jpe))$/", false, false, true);
	restoreFilter(5,"*.gif", "/(\\.gif)$/", false, false, true);
	restoreFilter(6,"*.png", "/(\\.png)$/", false, false, true);
	Preferences.set("extensions.dta.context.numfilters", defNumFilters);
}